diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambassador.cpp origin/libRTI/RTI1516ambassador.cpp
--- patched/libRTI/RTI1516ambassador.cpp	2012-01-19 14:45:53.000000000 +0400
+++ origin/libRTI/RTI1516ambassador.cpp	2011-10-03 11:01:21.000000000 +0400
@@ -1042,25 +990,24 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Delete_Object_Instance );
+		M_Delete_Object_Instance req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
 		if ( &theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL)
 		{
 			throw RTIinternalError(L"Calling deleteObjectInstance with Tag NULL") ;
 		}
 
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 
-		certi::FederateHandle certiHandle = rep->getEventRetraction().getSendingFederate();
-		uint64_t serialNum = rep->getEventRetraction().getSN();
-		DELETE_REP();
+		certi::FederateHandle certiHandle = rep.getEventRetraction().getSendingFederate();
+		uint64_t serialNum = rep.getEventRetraction().getSN();
 		return rti1516::MessageRetractionHandleFriend::createRTI1516Handle(certiHandle, serialNum);
 	}
 
@@ -1076,11 +1023,10 @@
 		RTIinternalError)
 	{ 
 		throw RTIinternalError(L"unimplemented service localDeleteObjectInstance");
-		DEFINE_REQ_REP( M_Local_Delete_Object_Instance );
+		M_Local_Delete_Object_Instance req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP(); 
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	// 6.13
@@ -1096,19 +1042,18 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Change_Attribute_Transportation_Type );
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));	
-		req->setTransportationType(toCertiTransportationType(theType));
+		M_Change_Attribute_Transportation_Type req, rep ;
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));	
+		req.setTransportationType(toCertiTransportationType(theType));
 		
-		req->setAttributesSize(theAttributes.size());
+		req.setAttributesSize(theAttributes.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = theAttributes.begin(); it != theAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(rti1516::AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(rti1516::AttributeHandleFriend::toCertiHandle(*it),i);
 		}
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 6.14
@@ -1122,13 +1067,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Change_Interaction_Transportation_Type );
+		M_Change_Interaction_Transportation_Type req, rep ;
 
-		req->setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theClass));
-		req->setTransportationType(toCertiTransportationType(theType));
+		req.setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theClass));
+		req.setTransportationType(toCertiTransportationType(theType));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 6.17
@@ -1143,22 +1087,21 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Request_Object_Attribute_Value_Update );
+		M_Request_Object_Attribute_Value_Update req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::requestObjectAttributeValueUpdate");
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 
 		size_t attr_num = theAttributes.size();
-		req->setAttributesSize( attr_num );
+		req.setAttributesSize( attr_num );
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = theAttributes.begin(); i < attr_num; ++it, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
-		req->setTag(varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(varLengthDataAsString(theUserSuppliedTag));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 		G.Out(pdGendoc,"exit  RTI1516ambassador::requestObjectAttributeValueUpdate");
 	}
 
@@ -1173,11 +1116,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Request_Class_Attribute_Value_Update );
+		M_Request_Class_Attribute_Value_Update req, rep ;
 		G.Out(pdGendoc,"enter RTI1516ambassador::requestClassAttributeValueUpdate");
-		req->setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
+		req.setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(theClass));
 
-		rep = assignAHSAndExecuteService( theAttributes, req, rep );
+		assignAHSAndExecuteService(theAttributes, req, rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::requestClassAttributeValueUpdate");
 	}
@@ -1197,18 +1140,17 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Unconditional_Attribute_Ownership_Divestiture );
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		M_Unconditional_Attribute_Ownership_Divestiture req, rep ;
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 
-		req->setAttributesSize(theAttributes.size());
+		req.setAttributesSize(theAttributes.size());
 		uint32_t i=0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = theAttributes.begin(); it != theAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i); 
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i); 
 		}
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 7.3
@@ -1225,22 +1167,21 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Negotiated_Attribute_Ownership_Divestiture );
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		M_Negotiated_Attribute_Ownership_Divestiture req, rep ;
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		if (&theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL) {
 			throw RTIinternalError (L"Calling negotiatedAttributeOwnershipDivestiture with Tag NULL") ;
 		}
-		req->setTag(rti1516::varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(rti1516::varLengthDataAsString(theUserSuppliedTag));
 		
-		req->setAttributesSize(theAttributes.size());
+		req.setAttributesSize(theAttributes.size());
 		uint32_t i=0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = theAttributes.begin(); it != theAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i); 
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i); 
 		}
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 7.6
@@ -1277,24 +1218,23 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Attribute_Ownership_Acquisition );
+		M_Attribute_Ownership_Acquisition req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		if (&theUserSuppliedTag == NULL || theUserSuppliedTag.data() == NULL )
 		{
 			throw RTIinternalError (L"Calling attributeOwnershipAcquisition with Tag NULL") ;
 		}
-		req->setTag(rti1516::varLengthDataAsString(theUserSuppliedTag));
+		req.setTag(rti1516::varLengthDataAsString(theUserSuppliedTag));
 		
-		req->setAttributesSize(desiredAttributes.size());
+		req.setAttributesSize(desiredAttributes.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = desiredAttributes.begin(); it != desiredAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
 		
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP(); 
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	// 7.9
@@ -1312,19 +1252,18 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Attribute_Ownership_Acquisition_If_Available );
+		M_Attribute_Ownership_Acquisition_If_Available req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		
-		req->setAttributesSize(desiredAttributes.size());
+		req.setAttributesSize(desiredAttributes.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = desiredAttributes.begin(); it != desiredAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 7.12 (in RTI1.3 this function is called: AttributeOwnershipReleaseResponse)
@@ -1340,16 +1279,16 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Attribute_Ownership_Release_Response );
+		M_Attribute_Ownership_Release_Response req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 
-		rep = assignAHSAndExecuteService( theAttributes, req, rep );
+		assignAHSAndExecuteService(theAttributes, req, rep);
 
-		if (rep->getExceptionType() == e_NO_EXCEPTION) {
+		if (rep.getExceptionType() == e_NO_EXCEPTION) {
 			theDivestedAttributes.clear();
-			for (uint32_t i=0;i<rep->getAttributesSize();++i) {
-				theDivestedAttributes.insert(rti1516::AttributeHandleFriend::createRTI1516Handle(rep->getAttributes()[i]));
+			for (uint32_t i=0;i<rep.getAttributesSize();++i) {
+				theDivestedAttributes.insert(rti1516::AttributeHandleFriend::createRTI1516Handle(rep.getAttributes()[i]));
 			}
 		}
 
@@ -1368,19 +1307,18 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Cancel_Negotiated_Attribute_Ownership_Divestiture );
+		M_Cancel_Negotiated_Attribute_Ownership_Divestiture req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		
-		req->setAttributesSize(theAttributes.size());
+		req.setAttributesSize(theAttributes.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = theAttributes.begin(); it != theAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 7.14
@@ -1396,19 +1334,18 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Cancel_Attribute_Ownership_Acquisition );
+		M_Cancel_Attribute_Ownership_Acquisition req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
 		
-		req->setAttributesSize(theAttributes.size());
+		req.setAttributesSize(theAttributes.size());
 		uint32_t i = 0;
 		for ( rti1516::AttributeHandleSet::const_iterator it = theAttributes.begin(); it != theAttributes.end(); it++, ++i)
 		{
-			req->setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
+			req.setAttributes(AttributeHandleFriend::toCertiHandle(*it),i);
 		}
-		
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	// 7.16
@@ -1422,13 +1359,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Query_Attribute_Ownership );
+		M_Query_Attribute_Ownership req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
-		req->setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theAttribute));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theAttribute));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 7.18
@@ -1442,15 +1378,14 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Is_Attribute_Owned_By_Federate );
+		M_Is_Attribute_Owned_By_Federate req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
-		req->setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theAttribute));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theAttribute));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		bool owned = (rep->getTag() == "RTI_TRUE") ? true : false;
-		DELETE_REP();
-		return owned;
+		privateRefs->executeService(&req, &rep);
+
+		return (rep.getTag() == "RTI_TRUE") ? true : false;
 	}
 
 	//////////////////////////////
@@ -1469,17 +1404,24 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Enable_Time_Regulation );
+		M_Enable_Time_Regulation req, rep ;
 
-		//req->setDate(certi_cast<RTIfedTime>()(theFederateTime).getTime());  //JRE: DATE IS NOT USED!
+		//req.setDate(certi_cast<RTIfedTime>()(theFederateTime).getTime());  //JRE: DATE IS NOT USED!
 		
 		//JRE: is dit wel goed?
 		//JvY: TODO Controleren of dit blijft werken met andere tijdsimplementaties
-		double * lookAheadTime = (double*) theLookahead.encode().data();
-		req->setLookahead(*lookAheadTime);
-
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		union ud {
+			double   dv;
+			uint64_t uv;
+		} value;
+#ifdef HOST_IS_BIG_ENDIAN
+		memcpy(&(value.uv), theLookahead.encode().data(), sizeof(double));
+#else
+		value.uv = CERTI_DECODE_DOUBLE_FROM_UINT64BE(theLookahead.encode().data());
+#endif
+		double lookAheadTime = value.dv;
+		req.setLookahead(lookAheadTime);
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.4
@@ -1490,9 +1432,9 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Time_Regulation );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Disable_Time_Regulation req, rep ;
+
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.5
@@ -1505,9 +1447,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Enable_Time_Constrained );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Enable_Time_Constrained req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.7
@@ -1518,9 +1459,8 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Time_Constrained );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Disable_Time_Constrained req, rep ;
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.8
@@ -1536,12 +1476,11 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Time_Advance_Request );
+		M_Time_Advance_Request req, rep ;
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		req.setDate(certiFedTime);
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.9
@@ -1557,13 +1496,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Time_Advance_Request_Available );
+		M_Time_Advance_Request_Available req, rep ;
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP(); 
+		privateRefs->executeService(&req, &rep); 
 	}
 
 	// 8.10
@@ -1579,13 +1517,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Next_Event_Request );
+		M_Next_Event_Request req, rep ;
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.11
@@ -1601,13 +1538,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Next_Event_Request_Available );
+		M_Next_Event_Request_Available req, rep ;
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.12
@@ -1625,13 +1561,12 @@
 	{ 
 		// JvY: Implementation copied from previous CERTI implementation, including immediate throw.
 		throw RTIinternalError(L"Unimplemented Service flushQueueRequest");
-		DEFINE_REQ_REP( M_Flush_Queue_Request );
+		M_Flush_Queue_Request req, rep ;
 
 		certi::FederationTime certiFedTime(certi_cast<RTI1516fedTime>()(theTime).getFedTime());
-		req->setDate(certiFedTime);
+		req.setDate(certiFedTime);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.14
@@ -1644,9 +1579,9 @@
 	{ 
 		// throw AsynchronousDeliveryAlreadyEnabled("Default value (non HLA)");
 
-		DEFINE_REQ_REP( M_Enable_Asynchronous_Delivery );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Enable_Asynchronous_Delivery req, rep ;
+
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.15
@@ -1657,9 +1592,9 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Disable_Asynchronous_Delivery );
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		M_Disable_Asynchronous_Delivery req, rep ;
+
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.16
@@ -1670,18 +1605,19 @@
 		RTIinternalError)
 	{ 
 		//TODO JRE: goed testen! Is GALT wel precies het zelfde als LBTS?
-		DEFINE_REQ_REP( M_Query_Lbts );
+		M_Query_Lbts req, rep ;
+
+		privateRefs->executeService(&req, &rep);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
 		//TODO JRE: goed testen of deze return value wel klopt!
-		certi::FederationTime fedTime = rep->getDate();
-		if (fedTime == NULL || fedTime.getTime() == 0) {
+		certi::FederationTime fedTime = rep.getDate();
+		if (fedTime.getTime() == 0.0) {
 			return false;
 		}	
 
 		// JvY: TODO Controleren of dit blijft werken met andere tijdsimplementaties
-		certi_cast<RTI1516fedTime>()(theTime) = rep->getDate().getTime();
-		DELETE_REP();
+		certi_cast<RTI1516fedTime>()(theTime) = rep.getDate().getTime();
+
 		return true;
 	}
 
@@ -1692,13 +1628,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Query_Federate_Time );
+		M_Query_Federate_Time req, rep ;
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 
 		// JvY: TODO Controleren of dit blijft werken met andere tijdsimplementaties
-		certi_cast<RTI1516fedTime>()(theTime) = rep->getDate().getTime();
-		DELETE_REP();
+		certi_cast<RTI1516fedTime>()(theTime) = rep.getDate().getTime();
 	}
 
 	// 8.18
@@ -1709,18 +1644,18 @@
 		RTIinternalError)
 	{ 
 		//TODO JRE: goed testen! Is LITS wel precies het zelfde als QueryMinNextEventTime?
-		DEFINE_REQ_REP( M_Query_Min_Next_Event_Time );
+		M_Query_Min_Next_Event_Time req, rep ;
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 
 		//TODO JRE: goed testen of deze return value wel klopt!
-		certi::FederationTime fedTime = rep->getDate();
-		if (fedTime == NULL || fedTime.getTime() == 0) {
+		certi::FederationTime fedTime = rep.getDate();
+		if (fedTime.getTime() == 0.0) {
 			return false;
 		}
 		// JvY: TODO Controleren of dit blijft werken met andere tijdsimplementaties
-		certi_cast<RTI1516fedTime>()(theTime) = rep->getDate().getTime();
-		DELETE_REP();
+		certi_cast<RTI1516fedTime>()(theTime) = rep.getDate().getTime();
+
 		return true;
 	}
 
@@ -1763,13 +1698,12 @@
 		RTIinternalError)
 	{ 
 		throw RTIinternalError(L"Unimplemented Service retract");
-		DEFINE_REQ_REP( M_Retract );
+		M_Retract req, rep ;
 		
 		certi::EventRetraction event = rti1516::MessageRetractionHandleFriend::createEventRetraction(theHandle);
-		req->setEventRetraction(event);
+		req.setEventRetraction(event);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	// 8.23
@@ -1785,12 +1719,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Change_Attribute_Order_Type );
+		M_Change_Attribute_Order_Type req, rep ;
 
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
-		req->setOrder(rti1516::toCertiOrderType(theType));
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theObject));
+		req.setOrder(rti1516::toCertiOrderType(theType));
 
-		rep = assignAHSAndExecuteService( theAttributes, req, rep );
+		assignAHSAndExecuteService(theAttributes, req, rep);
 	}
 
 	// 8.24
@@ -1804,13 +1738,12 @@
 		RestoreInProgress,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Change_Interaction_Order_Type );
+		M_Change_Interaction_Order_Type req, rep ;
 
-		req->setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theClass));
-		req->setOrder(rti1516::toCertiOrderType(theType));
+		req.setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theClass));
+		req.setOrder(rti1516::toCertiOrderType(theType));
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DELETE_REP();
+		privateRefs->executeService(&req, &rep);
 	}
 
 	//////////////////////////////////
@@ -2086,18 +2019,17 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Object_Class_Handle );
+		M_Get_Object_Class_Handle req, rep ;
 
 		G.Out(pdGendoc,"enter RTI1516ambassador::getObjectClassHandle");
 
 		std::string nameAsString(theName.begin(), theName.end());
-		req->setClassName(nameAsString);
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		req.setClassName(nameAsString);
+		privateRefs->executeService(&req, &rep);
 
 		G.Out(pdGendoc,"exit RTI1516ambassador::getObjectClassHandle");
-		rti1516::ObjectClassHandle rti1516Handle = ObjectClassHandleFriend::createRTI1516Handle(rep->getObjectClass());
-		
-		DELETE_REP();
+		rti1516::ObjectClassHandle rti1516Handle = ObjectClassHandleFriend::createRTI1516Handle(rep.getObjectClass());
+
 		return rti1516Handle;
 	}
 
@@ -2108,22 +2040,21 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Object_Class_Name );
+		M_Get_Object_Class_Name req, rep ;
 
 		certi::ObjectClassHandle certiHandle = ObjectClassHandleFriend::toCertiHandle(theHandle);
-		req->setObjectClass(certiHandle);
+		req.setObjectClass(certiHandle);
 		try {
-			rep = privateRefs->executeServiceTmpl(req,rep);
+			privateRefs->executeService(&req, &rep);
 		} catch (rti1516::ObjectClassNotDefined &e)
 		{
 			throw rti1516::InvalidObjectClassHandle(e.what());
 		}
 
-		std::string nameString = rep->getClassName();
+		std::string nameString = rep.getClassName();
 		std::wstring nameWString(nameString.begin(), nameString.end()); 
 
 		//return hla_strdup(rep.getClassName());
-		DELETE_REP();
 		return nameWString;
 	}
 
@@ -2137,14 +2068,14 @@
 		RTIinternalError)
 	{ 
 		G.Out(pdGendoc,"enter RTI::RTI1516ambassador::getAttributeHandle");
-		DEFINE_REQ_REP( M_Get_Attribute_Handle );
+		M_Get_Attribute_Handle req, rep ;
 
 		std::string nameAsString(theAttributeName.begin(), theAttributeName.end());
-		req->setAttributeName(nameAsString);
-		req->setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(whichClass));
+		req.setAttributeName(nameAsString);
+		req.setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(whichClass));
 
 		try {
-			rep = privateRefs->executeServiceTmpl(req,rep);
+			privateRefs->executeService(&req, &rep);
 		} catch (rti1516::ObjectClassNotDefined &e)
 		{
 			if ( ! whichClass.isValid() ) {
@@ -2154,10 +2085,10 @@
 			}
 		}
 
+
+
 		G.Out(pdGendoc,"exit  RTI::RTI1516ambassador::getAttributeHandle");
-		AttributeHandle handle = rti1516::AttributeHandleFriend::createRTI1516Handle(rep->getAttribute());
-		DELETE_REP();
-		return handle;
+		return rti1516::AttributeHandleFriend::createRTI1516Handle(rep.getAttribute());
 	}
 
 	// 10.5
@@ -2170,12 +2101,12 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Attribute_Name );
+		M_Get_Attribute_Name req, rep ;
 
-		req->setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theHandle));
-		req->setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(whichClass));
+		req.setAttribute(rti1516::AttributeHandleFriend::toCertiHandle(theHandle));
+		req.setObjectClass(rti1516::ObjectClassHandleFriend::toCertiHandle(whichClass));
 		try {
-			rep = privateRefs->executeServiceTmpl(req,rep);
+			privateRefs->executeService(&req, &rep);
 		} catch (rti1516::ObjectClassNotDefined &e)
 		{
 			if ( !whichClass.isValid() )
@@ -2198,9 +2129,9 @@
 		
 		//return hla_strdup(rep.getAttributeName());
 
-		std::string nameString = rep->getAttributeName();
+		std::string nameString = rep.getAttributeName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
-		DELETE_REP();
+
 		return nameWString;
 	}
 
@@ -2211,15 +2142,13 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Interaction_Class_Handle );
+		M_Get_Interaction_Class_Handle req, rep ;
 		std::string nameString(theName.begin(), theName.end());
-		req->setClassName(nameString);
+		req.setClassName(nameString);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		privateRefs->executeService(&req, &rep);
 
-		InteractionClassHandle handle = rti1516::InteractionClassHandleFriend::createRTI1516Handle(rep->getInteractionClass());
-		DELETE_REP();
-		return handle;
+		return rti1516::InteractionClassHandleFriend::createRTI1516Handle(rep.getInteractionClass());
 	}
 
 	// 10.7
@@ -2229,10 +2158,10 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Interaction_Class_Name );
-		req->setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theHandle));
+		M_Get_Interaction_Class_Name req, rep ;
+		req.setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(theHandle));
 		try {
-			rep = privateRefs->executeServiceTmpl(req,rep);
+			privateRefs->executeService(&req, &rep);
 		} catch (rti1516::InteractionClassNotDefined &e)
 		{
 			if ( !theHandle.isValid() )
@@ -2245,10 +2174,9 @@
 		}
 
 		//return hla_strdup(rep.getClassName());
-		std::string nameString = rep->getClassName();
+		std::string nameString = rep.getClassName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
 
-		DELETE_REP();
 		return nameWString;
 	}
 
@@ -2261,13 +2189,13 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Parameter_Handle );
+		M_Get_Parameter_Handle req, rep ;
 		std::string nameString(theName.begin(), theName.end());
-		req->setParameterName(nameString);
-		req->setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(whichClass));
+		req.setParameterName(nameString);
+		req.setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(whichClass));
 
 		try {
-			rep = privateRefs->executeServiceTmpl(req,rep);
+			privateRefs->executeService(&req, &rep);
 		} catch (rti1516::InteractionClassNotDefined &e)
 		{
 			if ( !whichClass.isValid() )
@@ -2279,9 +2207,7 @@
 			}
 		}
 
-		ParameterHandle handle = rti1516::ParameterHandleFriend::createRTI1516Handle(rep->getParameter());
-		DELETE_REP();
-		return handle;
+		return rti1516::ParameterHandleFriend::createRTI1516Handle(rep.getParameter());
 	}
 
 	// 10.9
@@ -2294,13 +2220,13 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Parameter_Name );
+		M_Get_Parameter_Name req, rep ;
 
-		req->setParameter(rti1516::ParameterHandleFriend::toCertiHandle(theHandle));
-		req->setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(whichClass));
+		req.setParameter(rti1516::ParameterHandleFriend::toCertiHandle(theHandle));
+		req.setInteractionClass(rti1516::InteractionClassHandleFriend::toCertiHandle(whichClass));
 
 		try {
-			rep = privateRefs->executeServiceTmpl(req,rep);
+			privateRefs->executeService(&req, &rep);
 		} catch (rti1516::InteractionClassNotDefined &e)
 		{
 			if ( !whichClass.isValid() )
@@ -2313,10 +2239,9 @@
 		}
 
 		//return hla_strdup(rep.getParameterName());
-		std::string nameString = rep->getParameterName();
+		std::string nameString = rep.getParameterName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
-		
-		DELETE_REP();
+
 		return nameWString;
 	}
 
@@ -2327,14 +2252,12 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Object_Instance_Handle );
+		M_Get_Object_Instance_Handle req, rep ;
 		std::string nameString(theName.begin(), theName.end());
-		req->setObjectInstanceName(nameString);
+		req.setObjectInstanceName(nameString);
 
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		ObjectInstanceHandle handle = rti1516::ObjectInstanceHandleFriend::createRTI1516Handle(rep->getObject());
-		DELETE_REP();
-		return handle;
+		privateRefs->executeService(&req, &rep);
+		return rti1516::ObjectInstanceHandleFriend::createRTI1516Handle(rep.getObject());
 	}
 
 	// 10.11
@@ -2344,15 +2267,14 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Object_Instance_Name );
-		req->setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theHandle));
-		rep = privateRefs->executeServiceTmpl(req,rep);
+		M_Get_Object_Instance_Name req, rep ;
+		req.setObject(rti1516::ObjectInstanceHandleFriend::toCertiHandle(theHandle));
+		privateRefs->executeService(&req, &rep);
 
 		//return hla_strdup(rep.getObjectInstanceName());
-		std::string nameString = rep->getObjectInstanceName();
+		std::string nameString = rep.getObjectInstanceName();
 		std::wstring nameWString(nameString.begin(), nameString.end());
-		
-		DELETE_REP();
+
 		return nameWString;
 	}
 
@@ -2363,15 +2285,13 @@
 		FederateNotExecutionMember,
 		RTIinternalError)
 	{ 
-		DEFINE_REQ_REP( M_Get_Dimension_Handle );
+		M_Get_Dimension_Handle req, rep ;
 
 		std::string nameString(theName.begin(), theName.end());
-		req->setDimensionName(nameString);
-		//req->setSpace(space);    //SPACE NIET NODIG IN 1516 STANDAARD???
-		rep = privateRefs->executeServiceTmpl(req,rep);
-		DimensionHandle handle = rti1516::DimensionHandleFriend::createRTI1516Handle(rep->getDimension());
-		DELETE_REP();
-		return handle;
+		req.setDimensionName(nameString);
+		//req.setSpace(space);    //SPACE NIET NODIG IN 1516 STANDAARD???
+		privateRefs->executeService(&req, &rep);
+		return rti1516::DimensionHandleFriend::createRTI1516Handle(rep.getDimension());
 	}
 
 	// 10.13
